# onioncard.py
# PUT YOUR NAME AND NETID HERE
# PUT DATE OF COMPLETION HERE
# Skeleton by Lillian Lee (LJL2), Apr 17, 2017

"""Module providing a class for playing cards for Crippling Mr. Onion, i.e.,
    with eight suits: spades, hearts, diamonds, clubs plus swords, cups, coins,
    and staves."""

## We do not include the fact that OnionCard is a subclass of Card in the
## user docstrings, because we don't want the user to think of OnionCards as
## special cases of Cards.  We are only subclassing to save ourselves some
## coding work.

import card # This is where we expect class Card to be defined
            # We aren't doing "from card import *" because we do NOT want to get
            # confused between variables of the same name in the current file vs.
            # the file card.py .


class OnionCard(card.Card):
    """Represents a Crippling Mr. Onion (CMO) card.

   Class variables:
        SUIT_NAMES: list of valid suit names:
            ['Clubs', 'Diamonds', 'Hearts', 'Spades', 'Staves', 'Coins', 'Cups', 'Swords']
        NUM_SUITS: number of valid suits: 8
        RANK_NAMES: translation table of ranks to names:
            RANK_NAME[1] is 'Ace',
            RANK_NAME[2] is '2',
            ...
            RANK_NAME[13] is 'King',
        NUM_RANKS: number of valid ranks: 13


    Instance Attributes:
        suit: The suit of this particular card.
              The name of this suit is given by OnionCard.SUIT_NAMES[suit].
              [int, in 0..OnionCard.NUM_SUITS-1]
        rank: The rank of this particular card.
              The name of this rank is given by OnionCard.RANK_NAMES[rank].
              [int, in 1..OnionCard.NUM_RANKS]

    For example, if we execute c = OnionCard(4, 12), OnionCard.SUIT_NAMES[c.suit]
    is 'Staves' and OnionCard.RANK_NAMES[c.rank] is '12', so this card is the
    Queen of Staves.
    """

    # class variable definitions
    SUIT_NAMES = card.Card.SUIT_NAMES + ['Staves', 'Coins', 'Cups', 'Swords']
    NUM_SUITS = len(SUIT_NAMES)

    def __init__(self, s, r):
        """Initializer: A new OnionCard with suit encoding s and rank encoding r.

        Preconditions: s in 0..self.NUM_SUITS-1 (inclusive) and
        r in 1..self.NUM_RANKS (inclusive)"""
        pass # REPLACE WITH A CALL TO THE __init__ METHOD OF Card

